Lattice Grid Buy a licence

demo D03

Thirty columns, thirty types

The realistic wide grid: text, numbers, dates, booleans, all at once

columns: [{ type: … }]

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
    { field: 'team', title: 'Team', filter: { type: 'set' } },
    { field: 'owner', title: 'Owner', filter: { type: 'set' } },
    { field: 'tier', title: 'Tier',
      cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
    { field: 'state', title: 'State',
      cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'active', title: 'Active', type: 'boolean' },
    { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
    { field: 'version', title: 'Version', layout: { width: 100 } },
    { field: 'instances', title: 'Instances', type: 'number' },
    { field: 'cpuCores', title: 'vCPU', type: 'number' },
    { field: 'memoryGb', title: 'Memory GB', type: 'number' },
    { field: 'diskBytes', title: 'Disk', type: 'number', format: { notation: 'compact' } },
    { field: 'requests', title: 'Requests', type: 'number', format: { notation: 'compact' } },
    { field: 'errors', title: 'Errors', type: 'number' },
    { field: 'errorRate', title: 'Error rate', type: 'number', format: { style: 'percent', decimals: 2 } },
    { field: 'p50Ms', title: 'p50 ms', type: 'number' },
    { field: 'p95Ms', title: 'p95 ms', type: 'number' },
    { field: 'p99Ms', title: 'p99 ms', type: 'number' },
    { field: 'uptime', title: 'Uptime', type: 'number', format: { style: 'percent', decimals: 3 } },
    { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
    { field: 'budget', title: 'Budget', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
    { field: 'headcount', title: 'Headcount', type: 'number', total: 'sum' },
    { field: 'openIncidents', title: 'Incidents', type: 'number', total: 'sum' },
    { field: 'lastDeploy', title: 'Last deploy', type: 'dateString' },
    { field: 'created', title: 'Created', type: 'dateString' },
    { field: 'slaTarget', title: 'SLA', type: 'number', format: { style: 'percent', decimals: 2 } },
    { field: 'onCall', title: 'On call' },
    { field: 'repository', title: 'Repository', layout: { width: 260 } },
    { field: 'notes', title: 'Notes' },
  ];

  const rows = [/* 20,000 service records */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        selection="multiple"
        toolPanel={{ side: 'left', panels: ['columns', 'filters', 'views', 'quick'],
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'services' }}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Configuring thirty columns of mixed types in one JavaScript data grid

Most production grids are not ten narrow text columns; they are a wide record with text, numbers, dates, booleans and the odd nested object side by side, each needing its own comparator, formatter and editor. This demo declares thirty such columns through the columns array, where each entry is an object with a type (columns: [{ type: … }]), so a date column sorts as a date and a boolean renders as a checkbox without extra wiring. Reach for this pattern whenever a dataset arrives already typed, rather than as a flat table of strings, and the grid needs to carry that typing through sorting, filtering and export rather than re-deriving it at render time.

Only the columns inside the visible horizontal band are mounted as DOM cells; the rest exist as data, not markup, so scrolling sideways across thirty columns does not mean thirty columns of live layout work at every frame. Keyboard navigation moves cell to cell across the full set with a single tab stop into the grid, and each header carries the row and column indices a screen reader needs to announce position correctly. A grid at thirty columns behaves the same as one at three, because the type information is declared once, per column, rather than inferred or hand-formatted per cell.

How do you configure column types in a JavaScript data grid?

Each entry in the columns array takes a type, such as 'text', 'number', 'date' or 'boolean', and the grid picks the matching comparator, formatter and default editor for that type. Shared behaviour across several columns is set once in columnDefaults rather than repeated on every entry, which keeps a thirty-column configuration readable and easy to audit for consistency.

Lattice Grid Buy a licence

demo D03

Thirty columns, thirty types

The realistic wide grid: text, numbers, dates, booleans, all at once

columns: [{ type: … }]

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
  { field: 'team', title: 'Team', filter: { type: 'set' } },
  { field: 'owner', title: 'Owner', filter: { type: 'set' } },
  { field: 'tier', title: 'Tier',
    cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
  { field: 'state', title: 'State',
    cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'active', title: 'Active', type: 'boolean' },
  { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
  { field: 'version', title: 'Version', layout: { width: 100 } },
  { field: 'instances', title: 'Instances', type: 'number' },
  { field: 'cpuCores', title: 'vCPU', type: 'number' },
  { field: 'memoryGb', title: 'Memory GB', type: 'number' },
  { field: 'diskBytes', title: 'Disk', type: 'number', format: { notation: 'compact' } },
  { field: 'requests', title: 'Requests', type: 'number', format: { notation: 'compact' } },
  { field: 'errors', title: 'Errors', type: 'number' },
  { field: 'errorRate', title: 'Error rate', type: 'number', format: { style: 'percent', decimals: 2 } },
  { field: 'p50Ms', title: 'p50 ms', type: 'number' },
  { field: 'p95Ms', title: 'p95 ms', type: 'number' },
  { field: 'p99Ms', title: 'p99 ms', type: 'number' },
  { field: 'uptime', title: 'Uptime', type: 'number', format: { style: 'percent', decimals: 3 } },
  { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
  { field: 'budget', title: 'Budget', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
  { field: 'headcount', title: 'Headcount', type: 'number', total: 'sum' },
  { field: 'openIncidents', title: 'Incidents', type: 'number', total: 'sum' },
  { field: 'lastDeploy', title: 'Last deploy', type: 'dateString' },
  { field: 'created', title: 'Created', type: 'dateString' },
  { field: 'slaTarget', title: 'SLA', type: 'number', format: { style: 'percent', decimals: 2 } },
  { field: 'onCall', title: 'On call' },
  { field: 'repository', title: 'Repository', layout: { width: 260 } },
  { field: 'notes', title: 'Notes' },
];

const rows = [/* 20,000 service records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    selection: 'multiple',
    toolPanel: { side: 'left', panels: ['columns', 'filters', 'views', 'quick'],
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'services' },
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Configuring thirty columns of mixed types in one JavaScript data grid

Most production grids are not ten narrow text columns; they are a wide record with text, numbers, dates, booleans and the odd nested object side by side, each needing its own comparator, formatter and editor. This demo declares thirty such columns through the columns array, where each entry is an object with a type (columns: [{ type: … }]), so a date column sorts as a date and a boolean renders as a checkbox without extra wiring. Reach for this pattern whenever a dataset arrives already typed, rather than as a flat table of strings, and the grid needs to carry that typing through sorting, filtering and export rather than re-deriving it at render time.

Only the columns inside the visible horizontal band are mounted as DOM cells; the rest exist as data, not markup, so scrolling sideways across thirty columns does not mean thirty columns of live layout work at every frame. Keyboard navigation moves cell to cell across the full set with a single tab stop into the grid, and each header carries the row and column indices a screen reader needs to announce position correctly. A grid at thirty columns behaves the same as one at three, because the type information is declared once, per column, rather than inferred or hand-formatted per cell.

How do you configure column types in a JavaScript data grid?

Each entry in the columns array takes a type, such as 'text', 'number', 'date' or 'boolean', and the grid picks the matching comparator, formatter and default editor for that type. Shared behaviour across several columns is set once in columnDefaults rather than repeated on every entry, which keeps a thirty-column configuration readable and easy to audit for consistency.